package com.baidu.netdisk.account

import android.app.Activity
import android.os.Build
import android.os.Handler
import android.os.Looper
import com.baidu.netdisk.R
import com.baidu.swan.application.init.NetDiskSwanAppInitHelper
import com.baidu.swan.launcher.NetdiskSwanAppLaunchHelper
import java.lang.ref.WeakReference

/**
 * 小程序扫码跳转
 *
 * @author rendawei
 * @since 2019/09/06
 */
internal class SwanSchemeHelper(activity: Activity) {

    private val mActivity: WeakReference<Activity> = WeakReference(activity)

    fun launchSwanApp(swanUrl: String) {
        if (!NetDiskSwanAppInitHelper.entranceOK()) {
            showNotSupportNotice()
            return
        }
        // 不进行拦截，直接加载
        NetdiskSwanAppLaunchHelper.launch(swanUrl)
    }

    private fun showNotSupportNotice() {
        Handler(Looper.getMainLooper()).post {
            mActivity.get()?.let {
                it.takeUnless {
                    it.isFinishing || (Build.VERSION.SDK_INT >= Build.VERSION_CODES.JELLY_BEAN_MR1 && it.isDestroyed)
                }?.apply {
                    QrLoginUtil.showSchemeNotValidDialog(this, R.string.qr_schema_swan_invalid_title, R.string.qr_schema_swan_invalid)
                }
            }
        }
    }
}
