package com.baidu.netdisk.p2p

import android.app.Notification
import android.os.Handler
import android.os.Message
import com.baidu.netdisk.kotlin.extension.Tag
import com.baidu.netdisk.p2p.NetdiskDownloadService.Companion.DOWNLOAD_ID
import com.baidu.netdisk.p2p.NetdiskDownloadService.Companion.DOWNLOAD_NOTIFICATION
import com.netdisk.library.objectpersistence.utils.d
import java.lang.ref.WeakReference

/**
 * 下载服务的消息分发
 *
 * @author wangyang34
 * @since 2019年11月19日
 *
 * @param reference 引用
 */
@Tag("P2PServiceHandler")
class P2PServiceHandler(val reference: WeakReference<NetdiskDownloadService>) : Handler() {

    override fun handleMessage(msg: Message) {
        var service: NetdiskDownloadService = reference.get() ?: return
        "handleMessage $msg".d()
        when(msg.what) {
            NetdiskDownloadService.MESSAGE_BIND_DOWNLOAD_NOTIFICATION -> {
                msg.data?.apply {
                    val notification = this.getParcelable(DOWNLOAD_NOTIFICATION) as Notification
                    val id = this.getInt(DOWNLOAD_ID)
                    service.bindDownloadNotification(notification, id)
                }
            }
            NetdiskDownloadService.MESSAGE_UNBIND_DOWNLOAD_NOTIFICATION -> service.unbindDownloadNotification()
        }
    }
}