package com.baidu.netdisk.qrunlock.server

import android.os.ResultReceiver
import com.baidu.netdisk.NetDiskApplication
import com.baidu.netdisk.account.AccountUtils
import com.baidu.netdisk.base.service.BaseJobService
import com.baidu.netdisk.base.service.BaseServiceHelper
import com.baidu.netdisk.base.service.constant.BaseExtras
import com.baidu.netdisk.base.service.constant.ServiceTypes
import com.baidu.netdisk.kernel.architecture.debug.NetDiskLog

/**
 *
 * @author dnegjie09
 * @description:
 * @date：2019-10-26 14:30
 *
 */
class QrUnlockServiceHelper {

    companion object {

        const val TAG = "QrUnlockServiceHelper"

        fun queryLockStatus(uuid: String, resultReceiver: ResultReceiver?) {

            NetDiskLog.d(IQRUnlockServiceConstant.QR_UNLOCK_TAG, "queryLockStatus")

            // 1、构造登录信息
            val bduss = AccountUtils.getInstance().bduss
            val uid = AccountUtils.getInstance().uid

            // 2、构造 Intent
            val intent = BaseServiceHelper.buildIntent(NetDiskApplication.getNetdiskApplication(), bduss, uid, resultReceiver)
            intent.putExtra(BaseExtras.EXTRA_SERVICE_TYPE, ServiceTypes.QR_UNLOCK)
            intent.putExtra(IQRUnlockServiceConstant.UUID, uuid)
            intent.action = QrUnlockService.QUERY_LOCK_STATUS

            // 3、启动服务
            BaseServiceHelper.startTargetVersionService(BaseJobService.QR_UNLOCK,
                    NetDiskApplication.getNetdiskApplication(), intent)


        }


        fun reportUnlock (uuid: String, status: String, resultReceiver: ResultReceiver?) {
            NetDiskLog.d(IQRUnlockServiceConstant.QR_UNLOCK_TAG, "reportUnlock")

            // 1、构造登录信息
            val bduss = AccountUtils.getInstance().bduss
            val uid = AccountUtils.getInstance().uid

            // 2、构造 Intent
            val intent = BaseServiceHelper.buildIntent(NetDiskApplication.getNetdiskApplication(), bduss, uid, resultReceiver)
            intent.putExtra(BaseExtras.EXTRA_SERVICE_TYPE, ServiceTypes.QR_UNLOCK)
            intent.putExtra(IQRUnlockServiceConstant.UUID, uuid)
            intent.putExtra(IQRUnlockServiceConstant.STATUS, status)
            intent.action = QrUnlockService.REPORT_UNLOCK

            // 3、启动服务
            BaseServiceHelper.startTargetVersionService(BaseJobService.QR_UNLOCK,
                    NetDiskApplication.getNetdiskApplication(), intent)

        }
    }

}