package com.baidu.netdisk.qrunlock.server.parser

import com.baidu.netdisk.kernel.architecture.debug.NetDiskLog
import com.baidu.netdisk.kernel.architecture.net.HttpResponse
import com.baidu.netdisk.kernel.architecture.net.parser.IApiResultParseable
import com.baidu.netdisk.qrunlock.server.IQRUnlockServiceConstant
import com.baidu.netdisk.qrunlock.server.response.ReportUnLockResponse
import com.google.gson.Gson
import com.google.gson.JsonIOException
import com.google.gson.JsonParseException
import com.google.gson.JsonSyntaxException
import org.json.JSONException
import java.io.IOException

/**
 *
 * @author dnegjie09
 * @description: 锁状态查询
 * @date：2019-10-26 17:57
 *
 */
class ReportUnLockParser: IApiResultParseable<ReportUnLockResponse> {
    override fun parse(response: HttpResponse): ReportUnLockResponse {

        val result = response.content

        NetDiskLog.d(IQRUnlockServiceConstant.QR_UNLOCK_TAG, "response.content : $result")

        return try {
            // 解析
            Gson().fromJson(result, ReportUnLockResponse::class.java)
        } catch (e: JsonSyntaxException) {
            throw JSONException(e.message)
        } catch (e: JsonIOException) {
            throw IOException(e.message)
        } catch (e: JsonParseException) {
            throw JSONException(e.message)
        } catch (e: IllegalArgumentException) {
            throw JSONException(e.message)
        }
    }
}