package com.baidu.netdisk.qrunlock.util

import android.app.Activity
import android.content.Context
import android.content.Intent
import com.baidu.netdisk.kernel.android.util.network.NetUtil
import com.baidu.netdisk.qrunlock.ui.QrPcUnlockActivity

/**
 *
 * @author dnegjie09
 * @description:
 * @date：2019-10-25 20:43
 *
 */


const val QR_UNLOCK_SCHEME = "bdnetdisk://n/action.PCYGJ_UNLOCK"

/**
 * 检查是否是二维码解锁 url
 */
fun checkQrUnlockScheme(url: String?): Boolean {

    if (!url.isNullOrEmpty()) {
        return url.startsWith(QR_UNLOCK_SCHEME)
    }
    return false
}


/**
 * 调起解锁页面
 * @param activity
 * @param url
 */
fun startQrPcUnlockactivity(activity: Activity, url: String?) {

    if (url.isNullOrEmpty()) {
        return
    }
    val intent = Intent(activity, QrPcUnlockActivity::class.java)

    intent.putExtra(QrPcUnlockActivity.QR_URL, url)

    activity.startActivity(intent)

}


/**
 * 网络检查
 */
fun isErrorNetWork(mContext: Context) = NetUtil.getNetWorkState(mContext) == NetUtil.NETWORK_NONE



