package com.baidu.netdisk.router.interceptor

import android.content.Context
import com.alibaba.android.arouter.facade.Postcard
import com.alibaba.android.arouter.facade.annotation.Interceptor
import com.alibaba.android.arouter.facade.callback.InterceptorCallback
import com.alibaba.android.arouter.facade.template.IInterceptor
import com.baidu.netdisk.R
import com.baidu.netdisk.util.ToastHelper
import com.baidu.swan.launcher.NetdiskSwanAppLaunchHelper

/**
 * 对小程序进行拦截
 *
 * @author zhangyong
 * @since 2019/12/04
 */
@Interceptor(priority = 2)
class SwanInterceptor : IInterceptor {
    var contextSwan: Context? = null

    override fun init(context: Context?) {
        contextSwan = context
    }

    override fun process(postcard: Postcard?, callback: InterceptorCallback?) {
        if (postcard?.path?.matches(Regex("^/\\w*/swan/\\w*")) == true) {
            (postcard.extras?.get("url") as? String)?.apply {
                 if (!NetdiskSwanAppLaunchHelper.launch(this)) {
                     ToastHelper.showLengthLongToast(contextSwan, R.string.aiapps_open_failed)
                 }
             }
        } else {
            callback?.onContinue(postcard)
        }
    }
}