package com.baidu.netdisk.arouter.interceptor

import android.content.Context
import com.alibaba.android.arouter.facade.Postcard
import com.alibaba.android.arouter.facade.annotation.Interceptor
import com.alibaba.android.arouter.facade.callback.InterceptorCallback
import com.alibaba.android.arouter.facade.template.IInterceptor
import com.alibaba.android.arouter.launcher.ARouter
import com.baidu.netdisk.router.UPGRADE_ACTIVITY_PATH
import com.baidu.netdisk.versionupdate.VersionUpdateUtils
import com.baidu.netdisk.wap.launch.Params

/**
 * 对url 版本升级的校验
 *
 * @author zhangyong
 * @since 2019/12/03
 */
@Interceptor(priority = 1)
class UpgradeInterceptor : IInterceptor {
    override fun process(postcard: Postcard?, callback: InterceptorCallback?) {
        // 判断是否需要升级
        (postcard?.extras?.get(Params.MIN_NETDISK_VERSION_NAME) as? String)?.apply {
            if (VersionUpdateUtils.checkUpgradeByVersionName(this)) {
                ARouter.getInstance().build(UPGRADE_ACTIVITY_PATH).withBoolean("isupgrade", true).navigation()
                return@process
            }
        }
        callback?.onContinue(postcard)
    }

    override fun init(context: Context?) {
    }
}