package com.baidu.netdisk.task.taskscore

import android.app.Activity
import com.baidu.netdisk.BaseActivity
import com.baidu.netdisk.base.utils.PersonalConfigKey
import com.baidu.netdisk.kernel.architecture.config.PersonalConfig
import com.baidu.netdisk.operation.taskscore.io.TaskScore
import com.baidu.netdisk.ui.CharacterLabelEditActivity
import com.baidu.netdisk.ui.CharacterLabelEditActivity.Companion.FROM_TASK_LIST
import com.baidu.netdisk.ui.CharacterLabelEditActivity.Companion.USERINFO_ACTIVITY_EDIT_LABLE_REQUEST
import org.json.JSONArray

/**
 * 设置标签的任务
 *
 * @author : linwentao
 * @since : On 2019-12-03
 */
class TaskScoreSetLable : TaskScoreHandler() {

    companion object {
        // 设置标签 - 个性标签页
        const val TASK_TYPE_SET_LABLE = "18"
    }

    override fun getTaskType(): String {
        return TASK_TYPE_SET_LABLE
    }

    override fun doTask(activity: Activity, taskScore: TaskScore?) {
        val lable = PersonalConfig.getInstance().getString(PersonalConfigKey.KEY_PERSONAL_TAG_CONFIG, "[]")
        val array = JSONArray(lable)
        CharacterLabelEditActivity.startActivity(activity as BaseActivity, array.toString(),
                FROM_TASK_LIST, USERINFO_ACTIVITY_EDIT_LABLE_REQUEST)
    }
}