package com.baidu.netdisk.task.taskscore

import android.app.Activity
import android.content.Intent
import com.baidu.netdisk.base.utils.FileCategory
import com.baidu.netdisk.cloudimage.ui.CloudImageFragment
import com.baidu.netdisk.cloudimage.ui.CloudImageFragmentWithStory
import com.baidu.netdisk.operation.taskscore.io.TaskScore
import com.baidu.netdisk.ui.cloudfile.MyCategoryActivity

/**
 * 故事积分任务
 *
 * @author wangyang34
 * @since 2019年8月5日
 */
class TaskScoreShareStory : TaskScoreHandler() {

    companion object {
        /** 故事任务类型 */
        const val TASK_TYPE_MESSAGE = "8"
    }

    override fun getTaskType(): String {
        return TASK_TYPE_MESSAGE
    }

    override fun doTask(activity: Activity?, taskScore: TaskScore) {
        val intent = Intent(activity, MyCategoryActivity::class.java)
        intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP or Intent.FLAG_ACTIVITY_SINGLE_TOP)
        intent.putExtra(MyCategoryActivity.EXTRA_CATEGORY, FileCategory.CATEGORY_IMAGE)
        intent.putExtra(CloudImageFragment.CLOUD_IMAGE_EXTRA_TAB_INDEX_KEY, CloudImageFragmentWithStory.INDEX_STORY_TAB)
        activity?.startActivity(intent)
    }
}