package com.baidu.netdisk.ui.businessplatform.extension

import android.app.Activity
import android.app.Dialog
import android.content.Context
import android.content.Intent
import android.support.annotation.StringRes
import android.support.v4.app.Fragment
import android.view.KeyEvent
import com.baidu.netdisk.kotlin.extension.invoke
import com.baidu.netdisk.ui.ITabSwitchable
import com.baidu.netdisk.ui.MainActivity
import com.baidu.netdisk.ui.widget.LoadingDialog
import com.baidu.netdisk.util.ToastHelper

/**
 * @author chencaixing
 * @time 2019-10-17 11:33
 */
fun Activity?.showLoading(@StringRes textRes: Int): Dialog? {
    return this?.run {
        return LoadingDialog.show(this, getString(textRes)).apply {
            setOnKeyListener { _, keyCode, _ ->
                keyCode == KeyEvent.KEYCODE_BACK
            }
        }
    }
}

fun Context.toast(@StringRes textRes: Int){
    ToastHelper.showToast(this, textRes)
}

fun Fragment.toast(@StringRes textRes: Int){
    activity?.toast(textRes)
}

fun Activity.startMainActivity(tabId: Int) {
    val intent = Intent(this, MainActivity::class.java)
            .addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP
                    or Intent.FLAG_ACTIVITY_SINGLE_TOP
                    or Intent.FLAG_ACTIVITY_NEW_TASK).invoke {
                ITabSwitchable.Extra.TAB_ID - tabId
            }

    startActivity(intent)
}