package com.baidu.netdisk.ui.cloudp2p

import android.app.Activity
import android.view.ViewGroup.LayoutParams.MATCH_PARENT
import android.widget.RelativeLayout
import com.baidu.netdisk.R
import com.baidu.netdisk.uiframe.container.*
import com.baidu.netdisk.uiframe.container.ContainerFactory.*
import com.baidu.netdisk.uiframe.container.LayoutContainerInfo.LAYOUT_CONTAINER_TYPE_RELATIVE_LAYOUT
import com.baidu.netdisk.uiframe.containerimpl.titlebar.CommonTitleBarInfo
import java.util.ArrayList

/**
 * 加群的确认页
 *
 * @author wangyang34
 * @since 2019年9月13日
 */
class GroupInfoActivity {

    /** relative */
    private val mRelative = LayoutContainerInfo(LAYOUT_CONTAINER_TYPE_RELATIVE_LAYOUT)

    /**
     * 打开页面
     *
     * @param activity activity
     * @param scheme 意图
     */
    fun openPage(activity: Activity, scheme: String) {
        CommonPageBuilder(activity)
                .addGroupNodeBegin(getRootContainerInfo())
                .addNode(getTitleContainerInfo())
                .addNode(getGroupRequestContainerInfo(scheme))
                .addNode(getGroupInfoContainerInfo(scheme))
                .addGroupNodeEnd()
                .show()
    }

    /**
     * 获取预加群请求容器信息
     * @param scheme 意图
     * @return 容器信息
     */
    private fun getGroupRequestContainerInfo(scheme: String): ContainerInfo {
        return ContainerInfo(CONTAINER_FRIEND_GROUP_REQUEST, scheme, null)
    }

    /**
     * 获取预加群的展示容器
     * @param scheme 意图
     * @return 容器信息
     */
    private fun getGroupInfoContainerInfo(scheme: String): ContainerInfo {
        val linearDecorator = LayoutDecoratorInfo()
        linearDecorator.mRule.add(LayoutRule(RelativeLayout.BELOW, R.id.title_bar_general_root_view));
        return ContainerInfo(CONTAINER_FRIEND_GROUP_INFO, scheme, linearDecorator)
    }

    /**
     * 获取预加群的title
     * @return 容器信息
     */
    private fun getTitleContainerInfo(): ContainerInfo {
        return ContainerInfo(CONTAINER_NORMAL_TITLEBAR,
                CommonTitleBarInfo(ArrayList<String>(), null, null), null)
    }

    /**
     * 获取根布局的容器信息
     *
     * @return 根布局的容器信息
     */
    private fun getRootContainerInfo(): ContainerInfo {
        val linearDecorator = LayoutDecoratorInfo()
        linearDecorator.mWidth = MATCH_PARENT
        linearDecorator.mHeight = MATCH_PARENT
        linearDecorator.mColorResource = R.color.bg_dn_home_page
        return ContainerInfo(CONTAINER_LAYOUT, mRelative, linearDecorator)
    }
}
