package com.baidu.netdisk.ui.cloudp2p.label

import android.app.Activity
import android.app.Dialog
import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.widget.Button
import android.widget.ImageView
import com.baidu.netdisk.R
import com.baidu.netdisk.base.storage.config.ConfigSearchLabelEntry
import com.baidu.netdisk.base.storage.config.ServerConfigKey
import com.baidu.netdisk.base.utils.PersonalConfigKey.LABEL_SEARCH_DIALOG_GUIDE_CONFIG
import com.baidu.netdisk.kernel.architecture.config.PersonalConfig
import com.baidu.netdisk.ui.cloudp2p.search.LabelSearchUtil

/**
 * 搜索框引导
 *
 * @author wangyang34
 * @since 2019/11/11
 */
class SearchLabelGuide {

    /**
     * 显示引导弹窗
     *
     * @param activity Activity
     */
    fun show(activity: Activity) {
        var isShown = PersonalConfig.getInstance().getBoolean(LABEL_SEARCH_DIALOG_GUIDE_CONFIG, false)
        if (isShown) {
            return
        }
        val info = ConfigSearchLabelEntry(ServerConfigKey
                .getCfgConfigBodyByType(ServerConfigKey.ConfigType.SEARCH_LABEL_ENTRY_CONFIG))
        if (!info.isShowDialog) {
            return
        }
        PersonalConfig.getInstance().putBoolean(LABEL_SEARCH_DIALOG_GUIDE_CONFIG, true)
        PersonalConfig.getInstance().asyncCommit()
        val dialog = Dialog(activity, R.style.BaiduNetDiskDialogTheme)
        val view = (activity.getSystemService(Context.LAYOUT_INFLATER_SERVICE) as LayoutInflater)
                .inflate(R.layout.dialog_label_search_guide, null)
        dialog.setContentView(view)
        // 确认按钮
        val buttonConfirm = dialog.findViewById<View>(R.id.dialog_button_confirm) as Button
        buttonConfirm.setOnClickListener {
            LabelSearchUtil().openPage(activity)
            dialog.dismiss()
        }
        // 右上角取消按钮
        val imageViewCancel = dialog.findViewById<View>(R.id.dialog_cancel) as ImageView
        imageViewCancel.setOnClickListener {
            dialog.dismiss()
        }
        dialog.setCanceledOnTouchOutside(false)
        dialog.show()
    }
}