package com.baidu.netdisk.ui.cloudp2p.search

import android.view.View
import com.baidu.netdisk.statistics.NetdiskStatisticsLogForMutilFields
import com.baidu.netdisk.uiframe.container.BaseContainer
import com.baidu.netdisk.uiframe.containerimpl.list.CommonRequestInfo
import com.baidu.netdisk.uiframe.containerimpl.list.ListStateContainer.LIST_STATE_FINISH
import com.baidu.netdisk.uiframe.message.CommonEvent
import com.baidu.netdisk.uiframe.message.MessageIDs.MESSAGE_COMMON_LIST_REQUEST
import com.baidu.netdisk.uiframe.message.MessageIDs.MESSAGE_STATE_CHANGE
import kotlin.math.max

/**
 * 搜索标签的特殊逻辑
 *
 * @author wangyang34
 * @since 2019/11/11
 */
class LabelSearchEmptyContainer : BaseContainer() {

    /** 已经上报过 */
    var mHasPost = true

    /** 列表数量 */
    var mListCount = 0

    override fun onCreateView(): View? {
        NetdiskStatisticsLogForMutilFields.getInstance().updateCount(
                NetdiskStatisticsLogForMutilFields.StatisticsKeys.SEARCH_LABEL_PAGE_SHOW_COUNT)
        return null
    }

    override fun onDestroyView() {
        super.onDestroyView()
        postListCount()
    }

    override fun onCommonEvent(event: CommonEvent?): Boolean {
        when(event?.what) {
            MESSAGE_COMMON_LIST_REQUEST -> {
                val info = event.obj as CommonRequestInfo
                if (!info.first) {
                    return false
                }
                postListCount()
                mHasPost = false
                mListCount = 0
            }
            MESSAGE_STATE_CHANGE -> {
                if (event.arg1 != LIST_STATE_FINISH || event.arg2 < 0) {
                    return false
                }
                mListCount = max(0, event.arg2 - 1)
            }
        }
        return false
    }

    /**
     * 数据上报
     */
    private fun postListCount() {
        if (mHasPost) {
            return
        }
        mHasPost = true
        NetdiskStatisticsLogForMutilFields.getInstance().updateCount(
                NetdiskStatisticsLogForMutilFields.StatisticsKeys.SEARCH_LABEL_PAGE_LIST_SHOW_COUNT,
                mListCount.toString())
    }
}