package com.baidu.netdisk.ui.cloudp2p.search

import android.view.View
import com.baidu.netdisk.kotlin.extension.Tag
import com.baidu.netdisk.kotlin.extension.d
import com.baidu.netdisk.uiframe.card.CommonCardInfo
import com.baidu.netdisk.uiframe.cardimpl.FriendSearchInfo
import com.baidu.netdisk.uiframe.container.BaseContainer
import com.baidu.netdisk.uiframe.containerimpl.list.CommonListResponse
import com.baidu.netdisk.uiframe.containerimpl.list.CommonRequestInfo
import com.baidu.netdisk.uiframe.message.CommonEvent
import com.baidu.netdisk.uiframe.message.MessageIDs
import com.baidu.netdisk.uiframe.message.MessageIDs.MESSAGE_COMMON_LIST_REQUEST_RESPONSE

/**
 * 标签搜索结果去重
 *
 * @author wangyang34
 * @since 2019/11/6
 */
@Tag("LabelSearchHandleResponse")
class LabelSearchHandleResponse : BaseContainer() {

    /** 已经存在的uk */
    private var mExistUK: HashSet<Long> = hashSetOf()

    override fun onCreateView(): View? {
        return null
    }

    override fun onCommonEvent(ev: CommonEvent): Boolean {
        when (ev.what) {
            MessageIDs.MESSAGE_COMMON_LIST_REQUEST -> {
                val info = ev.obj as CommonRequestInfo
                if (info.first) {
                    mExistUK.clear()
                }
            }
            MESSAGE_COMMON_LIST_REQUEST_RESPONSE -> {
                if (ev.obj is CommonListResponse) {
                    handleResponse(ev.obj as CommonListResponse)
                }
            }
        }
        return false
    }

    /**
     * 处理response数据
     * @param response 数据
     */
    private fun handleResponse(response: CommonListResponse) {
        if (response.mCardList == null) {
            return
        }
        "mExistUK  $mExistUK".d()
        var iterator = response.mCardList!!.iterator()
        while (iterator.hasNext()) {
            val cardInfo: CommonCardInfo? = iterator.next()
            if (cardInfo == null || cardInfo.data !is FriendSearchInfo) {
                continue
            }
            val friendSearchInfo = cardInfo.data as FriendSearchInfo
            "cardList  ${friendSearchInfo.uk}".d()
            if (!mExistUK.contains(friendSearchInfo.uk)) {
                mExistUK.add(friendSearchInfo.uk)
                continue
            }
            iterator.remove()
        }
        "mExistUK  $mExistUK".d()
    }
}