package com.baidu.netdisk.ui.gc

import android.app.Activity
import android.content.Intent
import android.support.v4.app.Fragment
import android.view.View
import com.baidu.netdisk.BaseActivity
import com.baidu.netdisk.R
import com.baidu.netdisk.gc.service.Extras
import com.baidu.netdisk.kotlin.extension.Tag
import com.baidu.netdisk.kotlin.extension.invoke
import com.baidu.netdisk.platform.extension.inTransaction
import com.baidu.netdisk.ui.widget.titlebar.BaseTitleBar
import com.baidu.netdisk.ui.widget.titlebar.ICommonTitleBarClickListener

@Tag("GarbageFileListActivity")
class GarbageFileListActivity : BaseActivity(), ICommonTitleBarClickListener {
    companion object {
        const val TASK_ID = "task_id"
        const val GARBAGE_FILE_COUNT = "garbage_file_count"
        const val GARBAGE_FILE_SPACE = "garbage_file_space"
        fun startActivity(activity: Activity, taskId: String?, fileCount: Int, fileSpace:
        Long, type: String = Extras.TYPE_EMPTY) {
            if (taskId.isNullOrEmpty()) {
                return
            }
            activity.startActivity(Intent(activity, GarbageFileListActivity::class.java).invoke {
                TASK_ID - taskId
                GARBAGE_FILE_COUNT - fileCount
                GARBAGE_FILE_SPACE - fileSpace
                Extras.GARBAGE_TYPE - type
            })
        }
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_garbage_file_list
    }

    override fun initView() {
        // initTitleBar
        mTitleBar = BaseTitleBar(this)
        mTitleBar.setRightLayoutVisible(false)
        mTitleBar.setTopTitleBarClickListener(this)
        supportFragmentManager.inTransaction {
            getFragment()?.apply {
                arguments = intent.extras
                replace(R.id.content, this)
            }
        }
    }

    private fun getFragment(): Fragment? = when (intent?.getStringExtra(Extras.GARBAGE_TYPE)) {
        Extras.TYPE_DUP -> DuplicateFileListFragment()
        Extras.TYPE_EMPTY -> EmptyFolderListFragment()
        else -> null
    }

    override fun onBackButtonClicked() {
        finish()
    }

    override fun onRightButtonClicked(view: View?) {

    }

}
