package com.baidu.netdisk.ui.gc

import android.content.Context
import android.widget.LinearLayout
import android.widget.TextView
import com.baidu.netdisk.R
import com.baidu.netdisk.base.storage.config.ConfigGarbageFile
import com.baidu.netdisk.base.storage.config.ServerConfigKey
import com.baidu.netdisk.businessplatform.extension.formatStorageSizePair
import com.baidu.netdisk.gc.service.Extras.TYPE_DUP
import com.baidu.netdisk.gc.service.Extras.TYPE_EMPTY
import com.baidu.netdisk.kotlin.extension.Tag
import com.baidu.netdisk.platform.extension.gone
import com.baidu.netdisk.ui.vip.VipActivity

@Tag("ScanGarbageAdapter")
class ScanGarbageAdapter(private val scanType: String) {
    private val cfg = ConfigGarbageFile(
            ServerConfigKey.getCfgConfigBodyByType(
                    ServerConfigKey.ConfigType.GARBAGE_FILE_CONFIG))

    val scanLimitBuySVipFrom :Int
       get() = when(scanType){
           TYPE_DUP -> VipActivity.GARBAGE_SCAN_DUP_TO_SVIP
           else -> VipActivity.GARBAGE_SCAN_EMPTY_TO_SVIP
       }

    val titleText: Int
        get() = when (scanType) {
            TYPE_DUP -> R.string.garbage_dupfile_clean_title
            TYPE_EMPTY -> R.string.garbage_empty_folder_clean_title
            else -> R.string.garbage_dupfile_clean_title
        }

    val scanningDesc: Int
        get() = when (scanType) {
            TYPE_DUP -> R.string.garbage_dupfile_scanning
            TYPE_EMPTY -> R.string.garbage_empty_folder_scanning
            else -> R.string.garbage_dupfile_scanning
        }

    val vipScanGarbageTimesGuideDesc: String
        get() = when (scanType) {
            TYPE_DUP -> cfg.vipScanGarbageTimesGuideDesc
            TYPE_EMPTY -> cfg.vipScanEmptyTimesGuideDesc
            else -> cfg.vipScanGarbageTimesGuideDesc
        }
    val vipScanGarbageTimesGuideDescMid: String
        get() = when (scanType) {
            TYPE_DUP -> cfg.vipScanGarbageTimesGuideDescMid
            TYPE_EMPTY -> cfg.vipScanEmptyTimesGuideDescMid
            else -> cfg.vipScanGarbageTimesGuideDescMid
        }
    val vipScanGarbageTimesButton: String
        get() = when (scanType) {
            TYPE_DUP -> cfg.vipScanGarbageTimesButton
            TYPE_EMPTY -> cfg.vipScanEmptyTimesButton
            else -> cfg.vipScanGarbageTimesButton
        }
    val vipScanGarbageTimesGuideUrl: String?
        get() = when (scanType) {
            TYPE_DUP -> cfg.vipScanGarbageTimesGuideUrl
            TYPE_EMPTY -> cfg.vipScanEmptyTimesGuideUrl
            else -> cfg.vipScanGarbageTimesGuideUrl
        }
    val scanGarbageTimesGuideDesc: String
        get() = when (scanType) {
            TYPE_DUP -> cfg.scanGarbageTimesGuideDesc
            TYPE_EMPTY -> cfg.scanEmptyTimesGuideDesc
            else -> cfg.scanGarbageTimesGuideDesc
        }
    val scanGarbageTimesGuideDescMid: String
        get() = when (scanType) {
            TYPE_DUP -> cfg.scanGarbageTimesGuideDescMid
            TYPE_EMPTY -> cfg.scanEmptyTimesGuideDescMid
            else -> cfg.scanGarbageTimesGuideDescMid
        }
    val scanGarbageTimesButton: String
        get() = when (scanType) {
            TYPE_DUP -> cfg.scanGarbageTimesButton
            TYPE_EMPTY -> cfg.scanEmptyTimesButton
            else -> cfg.scanGarbageTimesButton
        }
    val scanGarbageTimesGuideUrl: String?
        get() = when (scanType) {
            TYPE_DUP -> cfg.scanGarbageTimesGuideUrl
            TYPE_EMPTY -> cfg.scanEmptyTimesGuideUrl
            else -> cfg.scanGarbageTimesGuideUrl
        }

    val cleanButtonBottomDesc: Int
        get() = when (scanType) {
            TYPE_DUP -> R.string.garbage_dupfile_clean_same_tip
            TYPE_EMPTY -> R.string.garbage_clean_empty_folder_desc
            else -> R.string.garbage_dupfile_clean_same_tip
        }

    val noGarbageFileDesc: Int
        get() = when (scanType) {
            TYPE_DUP -> R.string.garbage_dupfile_scan_empty_desc
            TYPE_EMPTY -> R.string.garbage_no_empty_folder_desc
            else -> R.string.garbage_dupfile_scan_empty_desc
        }

    fun showSuccessView(context: Context, view: LinearLayout, totalFileNum: Int, totalSize: Long) {
        val topDesc = view.findViewById<TextView>(R.id.clean)
        val cleanUnit = view.findViewById<TextView>(R.id.gb)
        val cleanSize = view.findViewById<TextView>(R.id.clean_size)
        val bottomDesc = view.findViewById<TextView>(R.id.file_count)

        when (scanType) {
            TYPE_DUP -> {
                val size = totalSize.formatStorageSizePair()
                cleanSize.text = size.first
                cleanUnit.text = size.second
                bottomDesc.text = context.resources.getString(R.string.garbage_dupfile_file_count, totalFileNum)
            }
            TYPE_EMPTY -> {
                topDesc.gone()
                cleanSize.text = totalFileNum.toString()
                cleanUnit.text = "个"
                bottomDesc.text = context.resources.getString(R.string.garbage_dupfile_need_clean)
            }
        }
    }
}