package com.baidu.netdisk.ui.gc

import android.app.Activity
import android.content.Intent
import android.os.Bundle
import com.baidu.netdisk.BaseActivity
import com.baidu.netdisk.R
import com.baidu.netdisk.businessplatform.extension.updateCount
import com.baidu.netdisk.gc.service.Extras.GARBAGE_TYPE
import com.baidu.netdisk.gc.statistics.StatisticsKey
import com.baidu.netdisk.kotlin.extension.Tag
import com.baidu.netdisk.kotlin.extension.invoke
import com.baidu.netdisk.platform.extension.inTransaction
import com.baidu.netdisk.ui.businessplatform.extension.immerseGarbageStatusBar
import com.baidu.netdisk.ui.gc.GarbageMainActivity.Companion.FROM_OTHER
import com.baidu.netdisk.ui.gc.GarbageMainActivity.Companion.FROM_PARAS

@Tag("ScanGarbageFileActivity")
class ScanGarbageFileActivity : BaseActivity() {
    companion object {
        @JvmStatic
        fun getStartIntent(activity: Activity, from: Int, scanType: String): Intent {
            return Intent(activity, ScanGarbageFileActivity::class.java)() {
                FROM_PARAS - from
                GARBAGE_TYPE - scanType
            }
        }
    }

    private lateinit var fragment: ScanGarbageFileFragment

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        fragment = ScanGarbageFileFragment().apply {
            arguments = intent.extras
        }
        supportFragmentManager.inTransaction { replace(R.id.content, fragment) }

        // 扫描展现页面统计 （params：来源）
        val from = intent.getIntExtra(FROM_PARAS, FROM_OTHER)
        val type = intent.getStringExtra(GARBAGE_TYPE)
        StatisticsKey.GC_SCAN_PAGE_SHOW.updateCount(from.toString(), type)
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_scan_garbage_file
    }

    override fun initView() {

    }

    override fun onResume() {
        super.onResume()
        window.immerseGarbageStatusBar()
    }

    override fun onThemeUpdate() {
        super.onThemeUpdate()
        window.immerseGarbageStatusBar()
    }

    override fun onBackPressed() {
        if (::fragment.isInitialized)
            fragment.onBackKeyPressed()
        else
            super.onBackPressed()
    }
}