package com.baidu.netdisk.ui.gc.adapter

import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.TextView
import com.baidu.netdisk.R
import com.baidu.netdisk.base.imageloader.GlideHelper
import com.baidu.netdisk.base.utils.FileType
import com.baidu.netdisk.businessplatform.widget.BaseViewHolder
import com.baidu.netdisk.gc.io.parser.model.GarbageFileItem

/**
 * @author chencaixing
 * @time 2019-10-21 10:16
 */
class EmptyFolderAdapter(private var onSelectCountChange: (Int, Boolean) -> Unit) : RecyclerView
.Adapter<BaseViewHolder>() {
    private var mData = mutableListOf<GarbageFileItem>()

    private var mSelectAll = true

     fun onSelectAllStateChange() {
         mSelectAll = !mSelectAll
         mData.forEach {
             it.selected = mSelectAll
         }
         notifyDataSetChanged()
         onSelectCountChange(if (mSelectAll) itemCount else 0, mSelectAll)
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int) =
            BaseViewHolder(LayoutInflater.from(parent.context).inflate(R
                    .layout.item_empty_folder_list, parent, false))

    override fun getItemCount() = mData.size

    override fun onBindViewHolder(holder: BaseViewHolder, position: Int) {
        mData[position].apply {
            holder<TextView>(R.id.tv_path).text = path
            holder<TextView>(R.id.tv_name).text = server_filename
            GlideHelper.getInstance().displayImageFromDrawable(FileType.getType(server_filename,
                    true).mResourceIdList, holder.getView(R.id.iv_icon))
            holder<ImageView>(R.id.iv_check).isSelected = selected
            holder.itemView.setOnClickListener {
                val preSelected = selected
                selected = !preSelected
                val selectCount = getSelectCount()
                mSelectAll = selectCount == itemCount
                onSelectCountChange(selectCount, mSelectAll)
                notifyItemChanged(position)
            }
        }
    }

    fun getSelectItems() = mData.filter {
        it.selected
    }

    fun getSelectCount() = getSelectItems().size

    fun onDeleteSuccess() {
        mData.removeAll {
            it.selected
        }
        notifyDataSetChanged()
        onSelectCountChange(0,false)
    }

    fun setData(data: List<GarbageFileItem>) {
        if (mSelectAll) {
            data.forEach {
                it.selected = true
            }
            onSelectCountChange(itemCount + data.size, mSelectAll)
        }
        mData.addAll(data)
        notifyDataSetChanged()
    }
}