package com.baidu.netdisk.ui.preview.image

import android.text.TextUtils
import com.google.gson.Gson
import com.google.gson.annotations.SerializedName

/**
 * 大图预览底部的mispan配置
 *
 * @author wangyang34
 * @since 2019年12月5日
 */
class ConfigImageBottomDetail(json: String?) {

    /** 配置 */
    @SerializedName("config")
    var mItems: ArrayList<MoreOperationInfo>? = null

    /**
     * 初始化
     */
    init {
        if (!TextUtils.isEmpty(json)) {
            mItems = try {
                val config = Gson().fromJson(json, this.javaClass)
                config?.mItems
            } catch (ignore: Exception) {
                null
            }
        }
    }
}