package com.baidu.netdisk.ui.preview.unzip

import android.content.Context
import android.content.Intent
import android.graphics.drawable.AnimationDrawable
import android.os.Bundle
import android.os.Handler
import android.view.View
import com.baidu.netdisk.BaseActivity
import com.baidu.netdisk.R
import kotlinx.android.synthetic.main.activity_incentive_animation.*

/**
 * Created by linwentao on 2019/3/25.
 *
 * 激励视频的积分奖励动画页面
 */
class IncentivePointActivity : BaseActivity() {

    private var mTextContent: String? = null

    private var mAnimationDrawable: AnimationDrawable? = null

    private var mHandler: Handler? = null

    companion object {

        private const val EXTRA_KEY_CONTENT = "extra_key_content"

        /**
         * 启动Activity
         *
         * @param context
         * @param content 需要展示的文案
         */
        @JvmStatic
        fun startIncentiveActivity(context: Context, content: String) {
            val intent = Intent(context, IncentivePointActivity::class.java)
            intent.putExtra(EXTRA_KEY_CONTENT, content)
            context.startActivity(intent)
        }
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        mTextContent = intent.getStringExtra(EXTRA_KEY_CONTENT)
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_incentive_animation
    }

    override fun initView() {
        mAnimationDrawable = image!!.background as AnimationDrawable
        if (!mAnimationDrawable!!.isRunning) {
            mAnimationDrawable!!.start()
        }
        button!!.setOnClickListener { finish() }

        var duration = 0
        for (i in 0 until mAnimationDrawable!!.numberOfFrames) {
            duration += mAnimationDrawable!!.getDuration(i)
        }

        mHandler = Handler()
        mHandler!!.postDelayed({
            text!!.visibility = View.VISIBLE
            text!!.text = mTextContent
            button!!.visibility = View.VISIBLE
        }, (duration - 500).toLong())
    }

    override fun onDestroy() {
        super.onDestroy()
        if (mAnimationDrawable != null && mAnimationDrawable!!.isRunning) {
            mAnimationDrawable!!.stop()
        }
        mHandler!!.removeCallbacksAndMessages(null)
    }

    override fun isActivityDark(): Boolean {
        return true
    }
}