package com.baidu.netdisk.ui.quota

import android.graphics.Color
import android.graphics.drawable.ColorDrawable
import android.os.Bundle
import android.support.v4.app.DialogFragment
import android.view.Gravity
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.baidu.netdisk.R
import com.baidu.netdisk.businessplatform.extension.getActivityViewModel
import com.baidu.netdisk.businessplatform.extension.updateCount
import com.baidu.netdisk.businessplatform.statistics.StatisticsKey.QUOTA_LIMIT_POINT_SHOW
import com.baidu.netdisk.businessplatform.statistics.StatisticsKey.QUOTA_LIMIT_POINT_UNFREEZE_CLICK
import com.baidu.netdisk.kotlin.extension.Bundle
import com.baidu.netdisk.ui.quota.viewmodel.PointViewModel
import kotlinx.android.synthetic.main.dialog_point_unfreeze.*

/**
 * 积分解冻弹窗
 */
class PointUnfreezeDialog : DialogFragment() {

    companion object {
        private const val EVENT_ID = 20004
        private const val PEER_POINT = 5

        private const val EXTRA_CUR_POINT = "EXTRA_CUR_POINT"

        fun newInstance(curPoint: Int?):  PointUnfreezeDialog?{
            return if (curPoint != null)PointUnfreezeDialog().apply {
                arguments = Bundle {
                    EXTRA_CUR_POINT - curPoint
                }
            } else null
        }
    }

    private var curPoint: Int? = 0

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        dialog.window?.apply {
            decorView.setPadding(0, 0, 0, 0)
            setBackgroundDrawable(ColorDrawable(Color.TRANSPARENT))
            attributes.apply {
                width = ViewGroup.LayoutParams.MATCH_PARENT
                gravity = Gravity.BOTTOM or Gravity.CENTER_HORIZONTAL
            }
        }
        return inflater.inflate(R.layout.dialog_point_unfreeze, container, false)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        curPoint = arguments?.getInt(EXTRA_CUR_POINT)
        initView()
        QUOTA_LIMIT_POINT_SHOW.updateCount(curPoint.toString())
    }

    fun initView() {
        image_exit.setOnClickListener {
            dismiss()
        }
        cur_point.text = getString(R.string.quota_unlock_point, curPoint ?: 0)
        need_point.text = getString(R.string.quota_unlock_point, PEER_POINT)
        buy.setOnClickListener {
            activity?.let {
                val viewModel = getActivityViewModel<PointViewModel>()
                // 扣除积分
                viewModel?.consumePoint(it, PEER_POINT, EVENT_ID)
            }
            QUOTA_LIMIT_POINT_UNFREEZE_CLICK.updateCount()
            dismiss()
        }
    }

}