package com.baidu.netdisk.ui.quota

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.baidu.netdisk.R
import com.baidu.netdisk.base.storage.config.ConfigQuotaLimit
import com.baidu.netdisk.base.storage.config.ServerConfigKey
import com.baidu.netdisk.businessplatform.extension.updateCount
import com.baidu.netdisk.businessplatform.statistics.StatisticsKey.POINT
import com.baidu.netdisk.businessplatform.statistics.StatisticsKey.QUOTA_LIMIT_UNFREEZE_SUCCESS_ENTER_NETDISK
import com.baidu.netdisk.businessplatform.statistics.StatisticsKey.QUOTA_LIMIT_UNFREEZE_SUCCESS_SHOW
import com.baidu.netdisk.ui.ITabSwitchable
import com.baidu.netdisk.ui.businessplatform.extension.startMainActivity
import com.baidu.netdisk.ui.widget.BaseFragment
import kotlinx.android.synthetic.main.fragment_quota_point_unlocked.*

/**
 * 临时解冻成功的页面
 */
class QuotaPointUnlockFragment: BaseFragment() {
    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        super.onCreateView(inflater, container, savedInstanceState)
        return inflater.inflate(R.layout.fragment_quota_point_unlocked, null, false)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        initView()
        QUOTA_LIMIT_UNFREEZE_SUCCESS_SHOW.updateCount(POINT)
    }

    override fun onPause() {
        super.onPause()
        activity?.finish()
    }

    fun initView() {

        val config = ConfigQuotaLimit(ServerConfigKey.getCfgConfigBodyByType(ServerConfigKey
                .ConfigType.QUOTA_LIMIT_CONFIG))

        top_desc.text = config.pointEducationalCopy
        bottom_desc.text = config.pointEducationalCopyFrom

        enter_netdisk.setOnClickListener {
            activity?.apply {
                startMainActivity(ITabSwitchable.Id.HOME_ACTIVITY)
                QUOTA_LIMIT_UNFREEZE_SUCCESS_ENTER_NETDISK.updateCount(POINT)
                finish()
            }
        }
    }
}