package com.baidu.netdisk.ui.quota.viewmodel

import android.app.Application
import android.arch.lifecycle.AndroidViewModel
import android.arch.lifecycle.LifecycleOwner
import android.arch.lifecycle.Observer
import android.content.Context
import android.support.v4.app.FragmentActivity
import com.baidu.netdisk.businessplatform.extension.getService

class PointViewModel(application: Application): AndroidViewModel(application) {
    private val repository: PointRepository = PointRepository(getService())

    fun getMyPoint(context: Context, lifecycleOwner: LifecycleOwner, observer: Observer<Int>) {
        repository.queryMyPoint(context)
        repository.pointLiveData.observe(lifecycleOwner, observer)
    }

    fun consumePoint(activity: FragmentActivity, points: Int, eventId: Int) {
        repository.consumePoint(activity, points, eventId)
    }

    fun observeConsumePointResult(lifecycleOwner: LifecycleOwner, observer: Observer<Boolean>) {
        repository.isUnlockSuccess.observe(lifecycleOwner, observer)
    }
}