package com.baidu.netdisk.ui.quota.viewmodel

import android.arch.lifecycle.MutableLiveData
import android.content.Context
import android.os.Bundle
import android.os.Handler
import android.os.Looper
import com.baidu.netdisk.base.service.constant.BaseExtras
import com.baidu.netdisk.cloudfile.io.model.QuotaOverrunResponse
import com.baidu.netdisk.cloudfile.service.CloudFileServiceHelper
import com.baidu.netdisk.kotlin.extension.Tag
import com.baidu.netdisk.kotlin.extension.d
import com.baidu.netdisk.util.receiver.BaseResultReceiver
import com.baidu.netdisk.util.receiver.ErrorType
import com.baidu.netdisk.util.receiver.ResultView

@Tag("QuotaOverrunRepository")
class QuotaOverrunRepository {
    private val handler = Handler(Looper.getMainLooper())
    private val _quotaOverrunLiveData = MutableLiveData<QuotaOverrunResponse?>()
    val quotaOverrunLiveData
        get() = _quotaOverrunLiveData

    fun queryQuotaOverrunInfo(context: Context) {
        CloudFileServiceHelper.queryQuotaOverrunInfo(context, QuotaOverrunInfoResultReceiver
        (this, handler, null))
    }

    inner class QuotaOverrunInfoResultReceiver(reference: QuotaOverrunRepository, handler: Handler, view: ResultView?) :
            BaseResultReceiver<QuotaOverrunRepository>(reference, handler, view) {
        override fun onFailed(reference: QuotaOverrunRepository, errType: ErrorType, errno: Int, resultData: Bundle): Boolean {
            reference._quotaOverrunLiveData.value = null
            "onFailed".d()
            return super.onFailed(reference, errType, errno, resultData)
        }

        override fun onSuccess(reference: QuotaOverrunRepository, resultData: Bundle?) {
            super.onSuccess(reference, resultData)
            val info = resultData?.getParcelable<QuotaOverrunResponse>(BaseExtras.RESULT)
            "onSuccess".d()
            reference._quotaOverrunLiveData.value = info
        }
    }
}