package com.baidu.netdisk.ui.verify

import com.google.gson.Gson
import com.google.gson.annotations.SerializedName

/**
 * Hybrid 获取token参数
 *
 * @author wangyang34
 * @since 2019/9/2
 */
class VerifyCodeParam {

    companion object {

        /**
         * 解析
         *
         * @param jsonParam json参数
         * @return 解析参数
         */
        fun parse(jsonParam: String): VerifyCodeParam? {
            var verifyCodeParam: VerifyCodeParam
            try {
                verifyCodeParam = Gson().fromJson(jsonParam, VerifyCodeParam::class.java)
            } catch (e: Exception) {
                return null
            }
            return verifyCodeParam
        }
    }

    /** 校验后从server获取的token */
    @SerializedName("token")
    var mToken: String? = null

    /** 校验后从server获取的token的类型 */
    @SerializedName("verifyType")
    var mVerifyType: String? = null
}