package com.baidu.netdisk.ui.verify

import android.view.View
import android.webkit.*
import com.baidu.netdisk.ui.webview.NetDiskWebView

/**
 * 验证码校验的webclient 用于隐藏进度条
 *
 * @author wangyang34
 * @since 2019/9/2
 */
class VerifyWebChromeClient : WebChromeClient() {

    override fun onProgressChanged(view: WebView, newProgress: Int) {
        super.onProgressChanged(view, newProgress)

        val fragment = (view as NetDiskWebView).webViewFragment ?: return

        if (fragment.textLoading.visibility != View.GONE) {
            fragment.textLoading.visibility = View.GONE
        }
    }

    override fun onJsAlert(view: WebView, url: String, message: String, result: JsResult): Boolean {
        return false
    }

    override fun onJsConfirm(view: WebView, url: String, message: String, result: JsResult): Boolean {
        return false
    }

    override fun onJsPrompt(view: WebView, url: String, message: String, defaultValue: String,
                            result: JsPromptResult): Boolean {
        return false
    }
}