package com.baidu.netdisk.ui.vip

import android.os.Parcelable
import kotlinx.android.parcel.Parcelize

@Parcelize
data class PayResultBean(
        var list: ArrayList<Pair<String, String>>,
        var businessNo: String?,
        var orderNo: String?,
        var productName: String?,
        var phone: String?,
        var phoneMtime: String?,
        var orderType: Int?,
        var isAutoSvip: Int?,
        var actionUrl: String?,
        var orderOperationDesc: String?) : Parcelable {

    companion object {
        private const val VIP_ORDER = "vip1"
        /** 超级会员订单  */
        private const val SVIP_ORDER = "vip2"
        /** 空间容量订单**/
        private const val VOLUME_ORDER = "volume"
    }

    fun getProductType(): ProductType {
        return when {
           productName?.contains(VIP_ORDER) == true -> ProductType.VIP_PRODUCT
            productName?.contains(SVIP_ORDER) == true -> ProductType.SVIP_PRODUCT
            productName?.contains(VOLUME_ORDER) == true -> ProductType.VOLUME_PRODUCT
            else -> ProductType.OTHER_PRODUCT
        }
    }

    enum class ProductType{
        OTHER_PRODUCT,
        VIP_PRODUCT,
        SVIP_PRODUCT,
        VOLUME_PRODUCT
    }
}