package com.baidu.netdisk.ui.vip

import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import com.baidu.netdisk.R
import com.baidu.netdisk.platform.extension.gone

class PayResultPageAdapter() : RecyclerView.Adapter<RecyclerView.ViewHolder>() {
    var data: ArrayList<Pair<String, String>> = arrayListOf()
        set(value) {
            if (field != value) {
                field = value
                notifyDataSetChanged()
            }
        }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int) =
            PayResultHolder(LayoutInflater.from(parent.context).inflate(R.layout.item_pay_result_page_list, parent, false))


    override fun getItemCount() = data.size

    override fun onBindViewHolder(holder: RecyclerView.ViewHolder, position: Int) {
        if (holder is PayResultHolder) {
            holder.textKey.text = data[position].first
            holder.textValue.text = data[position].second
            holder.divider.gone(position == itemCount -1)
        }
    }

    class PayResultHolder(itemView: View) : RecyclerView.ViewHolder(itemView) {
        val textKey = itemView.findViewById<TextView>(R.id.item_text_key)
        val textValue = itemView.findViewById<TextView>(R.id.item_text_value)
        val divider = itemView.findViewById<View>(R.id.divider)
    }
}