package com.baidu.netdisk.ui.webview.hybrid.action

import android.os.Bundle
import android.os.ResultReceiver
import com.baidu.netdisk.base.service.constant.BaseStatus
import com.baidu.netdisk.cloudp2p.service.CloudP2PService
import com.baidu.netdisk.ui.verify.VerifyCodeParam
import com.baidu.netdisk.ui.view.IBaseView
import com.baidu.netdisk.ui.webview.hybrid.param.HybridUrlParam

/**
 * 验证码校验的hybrid
 *
 * @author wangyang34
 * @since 2019/9/2
 */
class HybridActionAbilityVerifyCode : HybridAction {

    /** 接收器 */
    private var mReceiver: ResultReceiver? = null

    companion object {

        /** 获取token方法名 */
        private const val FUNCTION_NAME_GET_TOKEN = "getToken"
    }

    /**
     * 构造
     *
     * @param IBaseView webview的接口
     * @param receiver 接收器
     */
    constructor(baseView: IBaseView, receiver: ResultReceiver?) : super(baseView) {
        mReceiver = receiver
    }

    override fun onAction(param: HybridUrlParam) {
        if (isDestroy) {
            return
        }
        if (param.mFuncName == FUNCTION_NAME_GET_TOKEN) {
            mBaseView?.activity?.finish()
            val verifyCodeParam = VerifyCodeParam.parse(param.mParams)
            val bundle = Bundle()
            bundle.putBoolean(CloudP2PService.EXTRA_VERIFY_CODE, true)
            bundle.putString(CloudP2PService.EXTRA_TOKEN, verifyCodeParam?.mToken)
            bundle.putString(CloudP2PService.EXTRA_CAPTCHA_TYPE, verifyCodeParam?.mVerifyType)
            mReceiver?.send(BaseStatus.SUCCESS, bundle)
        }
    }
}
