package com.baidu.netdisk.ui.webview.hybrid.action

import com.baidu.netdisk.BaseApplication
import com.baidu.netdisk.kernel.architecture.debug.NetDiskLog
import com.baidu.netdisk.trade.external.api.TradeCommonApiCompManager
import com.baidu.netdisk.ui.view.IBaseView
import com.baidu.netdisk.ui.webview.hybrid.HybridConfig
import com.baidu.netdisk.ui.webview.hybrid.param.HybridUrlParam
import org.json.JSONArray
import org.json.JSONObject

/**
 *
 * @author dnegjie09
 * @description: 获取下载的缓存
 * @date：2019-11-06 17:17
 *
 */
class HybridActionCacheState(baseView: IBaseView) : HybridAction(baseView) {


    companion object {

        const val TAG = "HybridActionCacheState"
        const val FUNCTION_NAME_GET_CACHE_STATE = "get"

    }

    override fun onAction(param: HybridUrlParam?) {
        NetDiskLog.d(TAG, "onAction")
        if (FUNCTION_NAME_GET_CACHE_STATE == param?.mFuncName) {
            getCacheState(param)
        } else {
            handleRecognizeSchemeError(param)
        }
    }

    private fun getCacheState(param: HybridUrlParam?) {

        try {
            NetDiskLog.d(TAG, "param?.mParams:" + param?.mParams)
            val json = JSONObject(param?.mParams)
            val jsonObject = JSONObject()
            if (!json.has("type")) {
                jsonObject.put("data", "[]")
                handleHybridCallback(param, HybridConfig.CALLBACK_SUCCESS, "", jsonObject)
                return
            }
            val result = JSONArray(TradeCommonApiCompManager.hybridActionGetCacheState(BaseApplication.mContext,
                    json.getString("pid"), (json.getString("type").toInt())))

            jsonObject.put("data", result)

            handleHybridCallback(param, HybridConfig.CALLBACK_SUCCESS, "", jsonObject)

        } catch (e: Exception) {
            NetDiskLog.e(HybridActionSystemDownPath.TAG, e.message, e)
        }
    }

}