package com.baidu.netdisk.ui.webview.hybrid.parser

import com.baidu.netdisk.kernel.architecture.debug.NetDiskLog
import com.baidu.netdisk.ui.webview.hybrid.param.MallShareParam
import com.google.gson.Gson
import com.google.gson.JsonIOException
import com.google.gson.JsonParseException
import com.google.gson.JsonSyntaxException

/**
 * 商城分享参数解析器
 * 
 * author guochao02
 * email guochao02@baidu.com
 * created 2019/11/7 15:34
 */
class MallShareParamParser : IParamParse<MallShareParam> {

    private val TAG = "MallShareParamParser"

    override fun parse(param: String?): MallShareParam? {
        var mallShareParam: MallShareParam? = null
        try {
            mallShareParam = Gson().fromJson<MallShareParam>(param, MallShareParam::class.java)
        } catch (e: JsonSyntaxException) {
            NetDiskLog.e(TAG, e.message, e)
        } catch (e: JsonIOException) {
            NetDiskLog.e(TAG, e.message, e)
        } catch (e: JsonParseException) {
            NetDiskLog.e(TAG, e.message, e)
        } catch (e: IllegalArgumentException) {
            NetDiskLog.e(TAG, e.message, e)
        }

        return mallShareParam
    }
}
