package com.baidu.netdisk.ui.webview.hybrid.parser

import com.baidu.netdisk.kernel.architecture.debug.NetDiskLog
import com.baidu.netdisk.ui.webview.hybrid.param.OpenTradeParam
import com.google.gson.Gson
import com.google.gson.JsonIOException
import com.google.gson.JsonParseException
import com.google.gson.JsonSyntaxException

class OpenTradeParamParser : IParamParse<OpenTradeParam> {

    private val TAG = "OpenTradeParamParser"

    override fun parse(param: String?): OpenTradeParam? {
        var openTradeParam: OpenTradeParam? = null
        try {
            openTradeParam = Gson().fromJson<OpenTradeParam>(param, OpenTradeParam::class.java)
        } catch (e: JsonSyntaxException) {
            NetDiskLog.e(TAG, e.message, e)
        } catch (e: JsonIOException) {
            NetDiskLog.e(TAG, e.message, e)
        } catch (e: JsonParseException) {
            NetDiskLog.e(TAG, e.message, e)
        } catch (e: IllegalArgumentException) {
            NetDiskLog.e(TAG, e.message, e)
        }

        return openTradeParam
    }

}