package com.baidu.netdisk.ui.xpan.classification

import android.os.Bundle
import android.os.Handler
import com.baidu.netdisk.kernel.architecture.debug.NetDiskLog
import com.baidu.netdisk.main.caller.FSCreateObjectApiCompManager
import com.baidu.netdisk.ui.cloudfile.INetdiskFilePresenter
import com.baidu.netdisk.ui.cloudfile.view.INetdiskFileView
import java.util.*

abstract class BaseCustomizeFragment : BaseSmartXFragment(), INetdiskFileView {

    companion object {
        const val TAG = "BaseCustomizeFragment"
    }

    var mNetDiskFilePresenter: INetdiskFilePresenter? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        isValidSuccess = validParam()
        if (!isValidSuccess) {
            finish()
            return
        }
        mNetDiskFilePresenter = FSCreateObjectApiCompManager.createNetdiskFilePresenter(this);
    }

    override fun getHandler(): Handler {
        return Handler()
    }

    override fun onRenameSuccess(oldPath: String?, newPath: String?, newName: String?) {
        NetDiskLog.d(TAG, "onRenameSuccess oldPath:$oldPath newPath:$newPath newName:$newName")
    }

    override fun onDeleteFailed(operation: Int) {
        NetDiskLog.d(TAG, "onDeleteFailed operation:$operation")
    }

    override fun onDiffFinished(resultCode: Int, resultData: Bundle?) {
        NetDiskLog.d(TAG, "onDiffFinished resultCode:$resultCode resultData:$resultData")
    }

    override fun setRefreshComplete(complete: Boolean) {
        NetDiskLog.d(TAG, "setRefreshComplete complete:$complete")
    }

    override fun getCurrentPath(): String {
        return ""
    }

    override fun handleCannotMoveFiles(canntMoveFiles: HashSet<Int>?) {
        NetDiskLog.d(TAG, "handleCannotMoveFiles canntMoveFiles:$canntMoveFiles")
    }

    override fun onGetDirectoryFinished() {
        NetDiskLog.d(TAG, "onGetDirectoryFinished")
    }

    override fun onCollectionSuccess(operation: Int) {
    }

    override fun cancelCollectionSuccess(operation: Int) {
    }

    override fun getZipFilePath(): String {
        return ""
    }

    override fun getSelectedSectionCount(): Int {
        return 0
    }
}