package com.baidu.netdisk.ui.xpan.extension

/**
 * 获取过期时间，单位为秒
 */
fun Long.getSecondLeftTime(label: String = "即将永久删除"): String {
    val leftTime = this
    return when {
        leftTime >= 24 * 60 * 60 -> {
            val days = leftTime / (24 * 60 * 60)
            "${days}天后$label"
        }
        leftTime in 60 * 60..24 * 60 * 60 -> {
            val hours = leftTime / (60 * 60)
            "${hours}小时后$label"
        }
        leftTime in 60..60 * 60 -> "${leftTime / 60}分钟后$label"
        else -> "1分钟后$label"
    }
}