package com.baidu.netdisk.ui.xpan.open

import android.app.Activity
import android.content.Intent
import android.net.Uri
import android.os.Bundle
import android.view.Window
import android.view.WindowManager
import com.baidu.netdisk.BaseActivity
import com.baidu.netdisk.wap.launch.IACTIONS

/**
 * 外链延迟业务承载页面
 * @author rendawei
 * @since 2019/09/26
 */
class XPanHolderActivity : BaseActivity() {

    private var schemeUri: Uri? = null
    private var schemeType: String? = null

    private var holderPresenter: XPanHolderPresenter? = null

    companion object {

        fun getHolderIntent(activity: Activity, uri: Uri, action: String): Intent? {
            return isSupport(action).takeIf {
                it
            }?.let {
                return Intent(activity, XPanHolderActivity::class.java).apply {
                    setDataAndType(uri, action)
                }
            }
        }

        private fun isSupport(action: String): Boolean {
            return when (action) {
                IACTIONS.XPAN_LINK -> true
                else -> false
            }
        }
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        requestWindowFeature(Window.FEATURE_NO_TITLE)
        window.setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN,
                WindowManager.LayoutParams.FLAG_FULLSCREEN)
        super.onCreate(savedInstanceState)
    }

    override fun getLayoutId(): Int {
        return NO_LAYOUT
    }

    override fun needSetStatusBar(): Boolean {
        return false
    }

    override fun initParams() {
        schemeUri = intent.data
        schemeType = intent.type
        if (schemeUri == null || schemeType == null) {
            finishHolder()
            return
        }
        holderPresenter = XPanHolderPresenter(schemeUri!!, schemeType!!, this)
    }

    override fun initView() {

    }

    fun finishHolder() {
        finish()
    }
}