package com.baidu.netdisk.ui.xpan.open

import android.net.Uri
import com.baidu.netdisk.account.PanLinkHelper
import com.baidu.netdisk.ui.xpan.panlink.PanlinkUtils
import com.baidu.netdisk.wap.launch.IACTIONS

class XPanHolderPresenter(private val dataUri: Uri, type: String,
                          private val activity: XPanHolderActivity) : XPanHolderListener {

    companion object {
        private const val PAN_LINK_UUID = "uuid"
    }

    override fun done() {
        activity.finishHolder()
    }

    init {
        when (type) {
            IACTIONS.XPAN_LINK -> {
                processPanLink()
            }
            else -> {
                done()
            }
        }
    }

    private fun processPanLink() {
        PanLinkHelper().apply {
            val uuid = dataUri.getQueryParameter(PAN_LINK_UUID)
            uuid.takeIf {
                uuid?.isNotEmpty() ?: false
            }?.let {
                val panLink = PanlinkUtils.generatePanLink(it)
                processPanLink(activity, panLink, this@XPanHolderPresenter)
            } ?: done()

        }
    }
}

interface XPanHolderListener {
    fun done()
}

