package com.baidu.netdisk.ui.xpan.transmission

import android.app.Dialog
import android.support.annotation.StringRes
import com.baidu.netdisk.R
import com.baidu.netdisk.ui.manager.DialogBuilder
import com.baidu.netdisk.ui.widget.BaseFragment

abstract class BaseLoadingFragment : BaseFragment() {

    private var mDialog: Dialog? = null

    fun showLoading(@StringRes resId: Int = R.string.xpan_loading, cancelCB: (() -> Unit)? = null) {
        mDialog = resId.takeIf {
            it > 0
        }?.let {
            DialogBuilder().buildLoadingDialog(activity, DialogBuilder.DISABLE_DIALOG_BUTTON,
                    it, DialogBuilder.DISABLE_DIALOG_BUTTON)?.apply {
                setCanceledOnTouchOutside(false)
                setOnCancelListener {
                    cancelCB?.invoke()
                }
            }
        } ?: DialogBuilder().buildLoadingDialogWithoutText(activity)?.apply {
            setCanceledOnTouchOutside(false)
            setOnCancelListener {
                cancelCB?.invoke()
            }
            show()
        }
    }

    fun dismissLoading() {
        mDialog?.takeIf {
            it.isShowing
        }?.apply {
            dismiss()
        }
    }
}