package com.baidu.netdisk.ui.xpan.transmission

import android.app.Dialog
import android.os.Bundle
import android.support.annotation.StringRes
import com.baidu.netdisk.BaseActivity
import com.baidu.netdisk.R
import com.baidu.netdisk.ui.manager.DialogBuilder

abstract class BaseTransActivity : BaseActivity() {

    private var mDialog: Dialog? = null

    fun showLoading(@StringRes resId: Int = R.string.xpan_loading, cancelCB: (() -> Unit)? = null) {
        mDialog = resId.takeIf {
            it > 0
        }?.let {
            DialogBuilder().buildLoadingDialog(this, DialogBuilder.DISABLE_DIALOG_BUTTON,
                    it, DialogBuilder.DISABLE_DIALOG_BUTTON)?.apply {
                setCanceledOnTouchOutside(false)
                setOnCancelListener {
                    cancelCB?.invoke()
                }
            }
        } ?: DialogBuilder().buildLoadingDialogWithoutText(this)?.apply {
            setCanceledOnTouchOutside(false)
            setOnCancelListener {
                cancelCB?.invoke()
            }
            show()
        }
    }

    fun dismissLoading() {
        mDialog?.takeIf {
            it.isShowing
        }?.apply {
            dismiss()
        }
    }

    open fun validateParams(savedInstanceState: Bundle? = null): Boolean = true
    open fun validateParams(): Boolean = true

    open fun fetchData(refresh: Boolean, loadMore: Boolean) {}

    override fun onDestroy() {
        super.onDestroy()
        dismissLoading()
    }
}