package com.baidu.netdisk.ui.xpan.transmission

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.baidu.netdisk.R
import com.baidu.netdisk.account.QrLoginUtil
import com.baidu.netdisk.statistics.NetdiskStatisticsLogForMutilFields
import com.baidu.netdisk.xpan.statistics.TransAssistStatisticsKeys
import kotlinx.android.synthetic.main.fragment_trans_assistant.*

/**
 * 传输助手首页
 *
 * @author rendawei
 * @since 2019/11/12
 */
class TransAssistantFragment : BaseTransAssistantFragment() {

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        return inflater.inflate(R.layout.fragment_trans_assistant, container, false)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        bt_collect.setOnClickListener {
            NetdiskStatisticsLogForMutilFields.getInstance().updateCount(TransAssistStatisticsKeys.TRANS_ASSIST_RECEIVE_FILE_CLICK)
            activity?.let {
                it.startActivity(TransAssistantActivity.getIntent(it, -1, pageType = TransAssistantActivity.PAGE_TYPE_COLLECT))
            }
        }
        bt_send.setOnClickListener {
            NetdiskStatisticsLogForMutilFields.getInstance().updateCount(TransAssistStatisticsKeys.TRANS_ASSIST_SEND_FILE_CLICK)
            QrLoginUtil.startQrScan(activity!!)
        }
    }
}