package com.baidu.netdisk.ui.xpan.transmission.adapter

import android.content.Context
import com.baidu.netdisk.widget.wheel.adapter.AbstractWheelTextAdapter

class NumericStepWheelAdapter(context: Context) : AbstractWheelTextAdapter(context) {

    private var mMiniValue: Int = 0
    private var mMaxValue: Int = 30
    private var mStep: Int = 1
    private var mOffset: Int = 0

    private val mFormat: String? = null

    constructor(context: Context, miniValue: Int, maxValue: Int) : this(context) {
        mMiniValue = miniValue
        mMaxValue = maxValue
    }

    constructor(context: Context, miniValue: Int, maxValue: Int, step: Int) : this(context) {
        mMiniValue = miniValue
        mMaxValue = maxValue
        mStep = step
    }

    constructor(context: Context, miniValue: Int, maxValue: Int, step: Int, offset: Int) : this(context) {
        mMiniValue = miniValue
        mMaxValue = maxValue
        mStep = step
        mOffset = offset
    }

    override fun getItemsCount(): Int {
        var count = 0
        for (index in (mMiniValue + mOffset)..mMaxValue step mStep) {
            count += 1
        }
        return count
    }

    override fun getItemText(index: Int): CharSequence {
        if (index in 0 until itemsCount) {
            var value = mMiniValue + index * mStep
            if (index >= 1) {
                value += mOffset
            }
            return if (mFormat != null) String.format(mFormat, value) else value.toString()
        }
        return ""
    }

    fun getSelectValue(index: Int): Int {
        if (index >= 1) {
            return mMiniValue + index * mStep + mOffset
        }
        return mMiniValue + index * mStep
    }

    fun getSelectIndex(value: Int): Int {
        if (value < (mMiniValue + mStep + mOffset)) {
            return 0
        }
        return (value - mMiniValue - mOffset) / mStep
    }
}