package com.baidu.netdisk.ui.xpan.transmission.adapter

import android.content.Context
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.RelativeLayout
import android.widget.TextView
import com.baidu.netdisk.R
import com.baidu.netdisk.cloudfile.utils.CloudFileHelper
import com.baidu.netdisk.kernel.util.DateUtil
import com.baidu.netdisk.xpan.io.parser.transmission.model.TransListBaseBean
import com.baidu.netdisk.xpan.io.parser.transmission.model.TransSendListBean
import java.util.concurrent.TimeUnit

class TransMySendAdapter(context: Context) : RecyclerView.Adapter<TransMySendAdapter.SendHolder>() {

    private val mInflater: LayoutInflater = LayoutInflater.from(context)
    val mDtas = mutableListOf<TransSendListBean>()

    var mItemClickListener: ((Int, View) -> Unit)? = null

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): SendHolder {
        val itemView = mInflater.inflate(R.layout.item_trans_my_send, parent, false)
        return SendHolder(itemView)
    }

    override fun getItemCount(): Int = mDtas.size

    override fun onBindViewHolder(holder: SendHolder, position: Int) {
        with(mDtas[position]) {
            val icon = CloudFileHelper.getFileIcon(fileName, !isFile)
            holder.ivIcom?.setImageResource(icon)
            holder.tvName?.text = fileName
            holder.tvTime?.text = DateUtil.formatTimeEndWithMin(TimeUnit.SECONDS.toMillis(ctime))
            holder.rlRoot?.setOnClickListener {
                mItemClickListener?.invoke(position, it)
            }
        }
    }

    fun addData(newData: MutableList<TransSendListBean>?) {
        mDtas.clear()
        newData?.takeIf {
            it.isNotEmpty()
        }?.let {
            mDtas.addAll(newData)
        }
        notifyDataSetChanged()
    }

    fun appendData(newData: MutableList<TransSendListBean>?) {
        newData?.takeIf {
            it.isNotEmpty()
        }?.let {
            mDtas.addAll(newData)
            notifyDataSetChanged()
        }
    }

    inner class SendHolder(val rootView: View) : RecyclerView.ViewHolder(rootView) {
        val rlRoot: RelativeLayout? = rootView.findViewById(R.id.rl_root)
        val ivIcom: ImageView? = rootView.findViewById(R.id.iv_file_icon)
        val tvName: TextView? = rootView.findViewById(R.id.tv_file_name)
        val tvTime: TextView? = rootView.findViewById(R.id.tv_file_time)
    }
}