package com.baidu.netdisk.ui.xpan.transmission.viewmodel

import android.app.Application
import android.arch.lifecycle.AndroidViewModel
import android.arch.lifecycle.MutableLiveData
import android.os.Bundle
import android.os.Handler
import com.baidu.netdisk.ui.xpan.extension.getBDuss
import com.baidu.netdisk.ui.xpan.extension.getUid
import com.baidu.netdisk.ui.xpan.extension.model.CustomResult
import com.baidu.netdisk.util.receiver.BaseResultReceiver
import com.baidu.netdisk.util.receiver.ErrorType
import com.baidu.netdisk.util.receiver.ResultView
import com.baidu.netdisk.xpan.ITransAssistant

class TransAssistantViewModel(application: Application) : AndroidViewModel(application) {

    var mTransAssManager: ITransAssistant? = null

    val mMsgLiveData = MutableLiveData<CustomResult<Any>>()
    private val mMsgReceiver = MsgResultReceiver(this, Handler(), null)

    fun getMsgTotalCount() {
        mTransAssManager?.getTotalMsgCount(getApplication(), mMsgReceiver, getBDuss(), getUid())
    }

    private inner class MsgResultReceiver(reference: TransAssistantViewModel, handler: Handler, resultView: ResultView?) :
            BaseResultReceiver<TransAssistantViewModel>(reference, handler, resultView) {
        override fun onSuccess(reference: TransAssistantViewModel, resultData: Bundle?) {
            super.onSuccess(reference, resultData)
            mMsgLiveData.postValue(CustomResult.success(Any()))
        }

        override fun onFailed(reference: TransAssistantViewModel, errType: ErrorType, errno: Int, resultData: Bundle): Boolean {
            mMsgLiveData.postValue(CustomResult.failure(errType, errno))
            return true
        }
    }
}