package com.baidu.netdisk.uiframe.card

import com.google.gson.JsonDeserializationContext
import com.google.gson.JsonDeserializer
import com.google.gson.JsonElement
import java.lang.reflect.Type

/**
 * 通用卡片解析
 *
 * @author wangyang34
 * @since 2019/11/6
 */
class CommonCardGsonDeserializer : JsonDeserializer<CommonCardInfo> {

    override fun deserialize(json: JsonElement?, typeOfT: Type?, context: JsonDeserializationContext?): CommonCardInfo? {
        json?.apply {
            return try {
                var type = asJsonObject.get("type").asInt
                var data = CardFactory().getInfoByTypeFromJson(type, asJsonObject.getAsJsonObject("data"))
                CommonCardInfo(type, data)
            } catch (e: Exception) {
                null
            }
        }
        return null
    }
}