package com.baidu.netdisk.uiframe.card

import com.google.gson.JsonDeserializationContext
import com.google.gson.JsonDeserializer
import com.google.gson.JsonElement
import java.lang.reflect.Type

/**
 * int类型解析
 *
 * @author wangyang34
 * @since 2019/11/15
 */
class IntCardGsonDeserializer : JsonDeserializer<Int> {

    override fun deserialize(json: JsonElement?, typeOfT: Type?, context: JsonDeserializationContext?): Int {
        json?.apply {
            return try {
                Integer.parseInt(asString)
            } catch (e: Exception) {
                0
            }
        }
        return 0
    }
}