package com.baidu.netdisk.uiframe.cardimpl

import android.os.Parcelable
import com.google.gson.annotations.SerializedName
import kotlinx.android.parcel.Parcelize

/**
 * author : linwentao
 * date : On 2019-11-06
 *
 * 搜索好友json序列化
 */
@Parcelize
class FriendSearchInfo (

        /** 用户标识 **/
        @SerializedName("uk")
        val uk: Long,

        /** 名称 **/
        @SerializedName("name")
        val name: String?,

        /** 百度账号 **/
        @SerializedName("uname")
        val uname: String,

        /** 展示名 **/
        @SerializedName("display_name")
        val displayName: String,

        /** 备注 **/
        @SerializedName("remark")
        val remark: String,

        /** 昵称 **/
        @SerializedName("nick_name")
        val nickName: String,

        /** 用户头像 **/
        @SerializedName("avatar_url")
        val avatarUrl: String,

        /** 好友关系 **/
        @SerializedName("follow_flag")
        var followFlag: Int,

        /** 双向好友关系 **/
        @SerializedName("rel")
        var rel: Int,

        /** 黑名单关系 **/
        @SerializedName("black_flag")
        val blackFlag: Int,

        /** 个性签名 **/
        @SerializedName("intro")
        val intro: String,

        /** 活跃度 **/
        @SerializedName("active")
        val active: String,

        /** 标签 **/
        @SerializedName("tags")
        val tags: Array<String>?

) : Parcelable