package com.baidu.netdisk.uiframe.containerimpl.list

import com.baidu.netdisk.kernel.architecture.net.HttpResponse
import com.baidu.netdisk.kernel.architecture.net.parser.IApiResultParseable
import com.baidu.netdisk.kernel.util.encode.Base64Util
import com.baidu.netdisk.kernel.util.encode.RC4Util
import com.baidu.netdisk.kotlin.extension.Tag

/**
 * 通用列表解析,带解密
 *
 * @author wangyang34
 * @since 2019/11/6
 */
@Tag("CommonListParser")
class CommonListParserEncode : IApiResultParseable<CommonListResponse> {

    override fun parse(response: HttpResponse?): CommonListResponse? {
        val data = response?.content
        val base64String = Base64Util.decode(data) ?: return null
        return ListParserHelper().parse(String(RC4Util.decrypt(base64String)))
    }
}