package com.baidu.netdisk.uiframe.containerimpl.list

import android.content.Context
import android.content.Intent
import android.os.ResultReceiver
import android.text.TextUtils
import com.baidu.netdisk.base.service.BaseScheduledService
import com.baidu.netdisk.kernel.architecture.job.PriorityScheduler
import com.baidu.netdisk.kotlin.extension.Tag
import com.baidu.netdisk.kotlin.extension.d

/**
 * 通用列表服务
 *
 * @author wangyang34
 * @since 2019/11/6
 */
@Tag("CommonListService")
class CommonListService(scheduler: PriorityScheduler?) : BaseScheduledService(scheduler) {

    companion object {

        /** 通用列表请求 action */
        const val ACTION_COMMON_LIST = "com.baidu.netdisk.ACTION_COMMON_LIST"

        /** 通用列表取消请求 action */
        const val ACTION_COMMON_LIST_CANCEL = "com.baidu.netdisk.ACTION_COMMON_LIST_CANCEL"

        /** 通用列表请求url */
        const val EXTRA_COMMON_LIST_URL = "com.baidu.netdisk.EXTRA_COMMON_LIST_URL"
    }

    override fun handleAction(intent: Intent?, bduss: String?, uid: String?, action: String?, receiver: ResultReceiver?, context: Context?) {
        if (TextUtils.isEmpty(action)) {
            return
        }
        "handleAction $action".d()
        when (action) {
            ACTION_COMMON_LIST -> {
                mScheduler.remove(CommonListJob.NAME)
                mScheduler.addJobWithMiddle(CommonListJob(context, intent, receiver, bduss, uid))
            }
            ACTION_COMMON_LIST_CANCEL -> {
                mScheduler.remove(CommonListJob.NAME)
            }
            else -> "do not handler action".d()
        }
    }
}