package com.baidu.netdisk.uiframe.containerimpl.list

import android.os.Parcelable
import com.baidu.netdisk.uiframe.containerimpl.list.ParserFactory.Companion.COMMON_PARSER
import kotlinx.android.parcel.Parcelize

/**
 * 网络请求的数据类型
 *
 * @author wangyang34
 * @since 2019/11/6
 *
 * @param first 是否是一个新的请求
 * @param url 地址
 * @param isPost 是否是post类型
 * @param params 请求参数
 */
@Parcelize
data class CommonRequestInfo(val first: Boolean,
                             val url: String,
                             val isPost: Boolean,
                             val params: List<Pair<String, String>>,
                             val parserType: Int = COMMON_PARSER) : Parcelable