package com.baidu.netdisk.uiframe.containerimpl.list

import com.baidu.netdisk.kotlin.extension.d
import com.baidu.netdisk.kotlin.extension.e
import com.baidu.netdisk.uiframe.card.CommonResponseGson
import com.google.gson.JsonIOException
import com.google.gson.JsonParseException
import com.google.gson.JsonSyntaxException
import org.json.JSONException
import java.io.IOException

/**
 * 通用列表解析
 *
 * @author wangyang34
 * @since 2019/11/6
 */
class ListParserHelper {

    /**
     * 解析
     *
     * @param data json串
     * @return response
     */
    fun parse(data: String?): CommonListResponse {
        var result: CommonListResponse? = null
        try {
            "$data".d()
            result = CommonResponseGson().gson
                    .fromJson(data, CommonListResponse::class.java)
        } catch (e: JsonSyntaxException) {
            e.e()
        } catch (e: JsonIOException) {
            e.e()
        } catch (e: JsonParseException) {
            e.e()
        } catch (e: IllegalArgumentException) {
            e.e()
        } catch (e: IOException) {
            e.e()
        }
        if (result == null) {
            throw JSONException(" JsonParser is null.")
        }
        return result
    }
}