package com.baidu.netdisk.uiframe.containerimpl.list

import com.baidu.netdisk.base.network.BaseApi
import com.baidu.netdisk.base.network.NetworkTask
import com.baidu.netdisk.kernel.architecture.net.HttpParams
import com.baidu.netdisk.kotlin.extension.Tag
import com.baidu.netdisk.kotlin.extension.d

/**
 * 通用列表api
 *
 * @author wangyang34
 * @since 2019/11/6
 */
@Tag("ListRequestApi")
class ListRequestApi(bduss: String?, uid: String?) : BaseApi(bduss, uid) {

    @Throws(Exception::class)
    fun getList(info: CommonRequestInfo): CommonListResponse? {
        val params = HttpParams()
        for (param in info.params) {
            params.add(param.first, param.second)
        }
        val httpRequest = if (info.isPost) {
            buildPostRequest(info.url, params)
        } else {
            buildGetRequest(info.url, params)
        }
        "ListRequestApi $info".d()
        return NetworkTask<CommonListResponse>().send(httpRequest, ParserFactory().getParserType(info.parserType))
    }
}