package com.baidu.netdisk.uiframe.containerimpl.list

import com.baidu.netdisk.kernel.architecture.net.parser.IApiResultParseable

/**
 * 网络解析工厂
 *
 * author : linwentao
 * date : On 2019-11-13
 */
class ParserFactory {

    companion object {

        /** 通用解析 **/
        const val COMMON_PARSER = 0

        /** 加密解析 **/
        const val ENCODE_PARSER = 1
    }

    /**
     * 通过类型获取解析类型
     *
     * @param type 类型
     * @return 解析类型
     */
    fun getParserType(type: Int) : IApiResultParseable<CommonListResponse> {
        return when(type) {
            COMMON_PARSER -> CommonListParser()
            ENCODE_PARSER -> CommonListParserEncode()
            else -> CommonListParser()
        }
    }
}