package com.baidu.netdisk.uiframe.containerimpl.sug

import com.baidu.netdisk.base.network.BaseApi
import com.baidu.netdisk.base.network.NetworkTask
import com.baidu.netdisk.base.network.ServerURL
import com.baidu.netdisk.kernel.architecture.debug.NetDiskLog
import com.baidu.netdisk.kernel.architecture.net.HttpParams

/**
 * sug请求接口类
 *
 * @author xujing31
 * @since 2019/11/7
 */
class SugApi(bduss: String?, uid: String?) : BaseApi(bduss, uid)  {

    /**
     * 获取Sug
     * @param inputText 用户输入的文本
     * @return SugResponse 请求结果
     */
    @Throws(Exception::class)
    fun getSug(inputText: String?): SugResponse? {
        var url = ServerURL.getRequestSugUrl()

//        if (NetDiskLog.isDebug()) {
//            url = "http://cp01-appsearch-33.epc.baidu.com:8080/ndrelation/tag/suggest"
//        }

        val params = HttpParams()
        params.add("word", inputText)
        return NetworkTask<SugResponse>().send(buildGetRequest(url, params), SugParser())
    }
}