package com.baidu.netdisk.uiframe.containerimpl.sug

import com.baidu.netdisk.base.service.BaseServiceHelper
import com.baidu.netdisk.kernel.architecture.net.HttpResponse
import com.baidu.netdisk.kernel.architecture.net.parser.IApiResultParseable
import com.baidu.netdisk.kotlin.extension.e
import com.google.gson.Gson
import com.google.gson.JsonIOException
import com.google.gson.JsonParseException
import com.google.gson.JsonSyntaxException
import org.json.JSONException
import java.io.IOException

/**
 * sug请求结果解析类
 *
 * @author xujing31
 * @since 2019/11/7
 */
class SugParser : IApiResultParseable<SugResponse> {

    override fun parse(response: HttpResponse?): SugResponse {
        var result: SugResponse? = null
        try {
            var content = response?.content
            result = Gson().fromJson(content, SugResponse::class.java)
        } catch (e: JsonSyntaxException) {
            e.e()
        } catch (e: JsonIOException) {
            e.e()
        } catch (e: JsonParseException) {
            e.e()
        } catch (e: IllegalArgumentException) {
            e.e()
        } catch (e: IOException) {
            e.e()
        }
        if (result == null) {
            throw JSONException(" JsonParser is null.")
        }
        if (result.errno != 0) {
            throw BaseServiceHelper.buildRemoteException(result.errno, null, result)
        }
        return result
    }
}