package com.baidu.netdisk.uiframe.containerimpl.sug

import android.content.Context
import android.content.Intent
import android.os.ResultReceiver
import android.text.TextUtils
import com.baidu.netdisk.base.service.BaseScheduledService
import com.baidu.netdisk.kernel.architecture.job.PriorityScheduler
import com.baidu.netdisk.kotlin.extension.Tag
import com.baidu.netdisk.kotlin.extension.d

/**
 * sug服务
 *
 * @author xujing31
 * @since 2019/11/7
 */
@Tag("SugService")
class SugService(scheduler: PriorityScheduler?) : BaseScheduledService(scheduler)  {

    companion object {

        /** 获取sug请求 action */
        const val ACTION_REQUEST_SUG = "com.baidu.netdisk.ACTION_REQUEST_SUG"

        /** 取消sug请求 action */
        const val ACTION_CANCEL_REQUEST_SUG = "com.baidu.netdisk.ACTION_CANCEL_REQUEST_SUG"

        /** 获取sug带的输入的文字 */
        const val EXTRA_INPUT_TEXT = "com.baidu.netdisk.EXTRA_INPUT_TEXT"

    }

    override fun handleAction(intent: Intent?, bduss: String?, uid: String?, action: String?, receiver: ResultReceiver?, context: Context?) {
        if (TextUtils.isEmpty(action)) {
            return
        }
        when (action) {
            ACTION_REQUEST_SUG -> {
                mScheduler.remove(RequestSugJob.NAME)
                mScheduler.addJobWithMiddle(RequestSugJob(context, intent, receiver, bduss, uid))
            }
            ACTION_CANCEL_REQUEST_SUG -> {
                mScheduler.remove(RequestSugJob.NAME)
            }
            else -> "do not handler action".d()
        }
    }
}