package com.baidu.netdisk.videoservice.service.clear

import android.os.Build
import android.support.annotation.RequiresApi
import com.baidu.netdisk.base.network.BaseApi
import com.baidu.netdisk.base.network.NetworkTask
import com.baidu.netdisk.base.network.ServerURL
import com.baidu.netdisk.kernel.architecture.net.HttpParams
import com.baidu.netdisk.kernel.architecture.net.exception.RemoteException
import org.json.JSONArray
import org.json.JSONException
import java.io.IOException
import java.security.KeyManagementException
import java.security.KeyStoreException
import java.security.NoSuchAlgorithmException
import java.security.UnrecoverableKeyException

/**
 * Created by linwentao on 2019/4/24.
 */
class VideoRecentClearApi(token: String, uid: String) : BaseApi(token, uid) {

    @RequiresApi(Build.VERSION_CODES.KITKAT)
    @Throws(JSONException::class, RemoteException::class, UnrecoverableKeyException::class,
            NoSuchAlgorithmException::class, KeyManagementException::class,
            KeyStoreException::class, IOException::class)

    fun clearRecentData(fsids: Array<String>, clear: Int): VideoRecentDeleteResponse? {
        val url = ServerURL.getPanDomain() + "/recent/video/delete"
        val fsidLong = Array<Long>(fsids.size, { 0 })
        for (i in 0..(fsids.asList().size - 1)) {
            fsidLong[i] = fsids.asList().get(i).toLong()
        }
        val params = HttpParams().apply {
            add("fsid_list", JSONArray(fsidLong).toString())
            add("clear", clear.toString())
        }
        return NetworkTask<VideoRecentDeleteResponse>().send(buildPostRequest(url, params), VideoRecentClearParser())
    }
}