package com.baidu.netdisk.videoservice.service.clear

import com.baidu.netdisk.kernel.architecture.debug.NetDiskLog
import com.baidu.netdisk.kernel.architecture.net.HttpResponse
import com.baidu.netdisk.kernel.architecture.net.exception.RemoteException
import com.baidu.netdisk.kernel.architecture.net.parser.IApiResultParseable
import com.google.gson.Gson
import com.google.gson.JsonIOException
import com.google.gson.JsonParseException
import com.google.gson.JsonSyntaxException
import org.json.JSONException
import java.io.IOException

/**
 * Created by linwentao on 2019/4/24.
 */
class VideoRecentClearParser : IApiResultParseable<VideoRecentDeleteResponse> {

    companion object {
        private val TAG = "VideoRecentClearParser"
    }

    @Throws(IOException::class, RemoteException::class, JSONException::class)
    override fun parse(response: HttpResponse): VideoRecentDeleteResponse {

        val result = response.content

        val videoRecentClearResponse: VideoRecentDeleteResponse = try {
            Gson().fromJson(result, VideoRecentDeleteResponse::class.java)
        } catch (e: JsonSyntaxException) {
            throw JSONException(e.message)
        } catch (e: JsonIOException) {
            throw IOException(e.message)
        } catch (e: JsonParseException) {
            throw JSONException(e.message)
        } catch (e: IllegalArgumentException) {
            throw JSONException(e.message)
        }

        NetDiskLog.d(TAG, "reportResponse:$videoRecentClearResponse")

        return videoRecentClearResponse
    }
}