package com.baidu.netdisk.videoservice.service.list

import com.baidu.netdisk.base.network.BaseApi
import com.baidu.netdisk.base.network.NetworkTask
import com.baidu.netdisk.base.network.ServerURL
import com.baidu.netdisk.kernel.architecture.net.exception.RemoteException
import org.json.JSONException
import java.io.IOException
import java.security.KeyManagementException
import java.security.KeyStoreException
import java.security.NoSuchAlgorithmException
import java.security.UnrecoverableKeyException

/**
 * Created by linwentao on 2019/4/24.
 */
class VideoRecentListApi(token: String, uid: String) : BaseApi(token, uid) {

    @Throws(JSONException::class, RemoteException::class, UnrecoverableKeyException::class,
            NoSuchAlgorithmException::class, KeyManagementException::class,
            KeyStoreException::class, IOException::class)

    fun getRecentListData(): VideoRecentListResponse? {
        val url = ServerURL.getPanDomain() + "/recent/video/list"
        return NetworkTask<VideoRecentListResponse>().send(buildGetRequest(url), VideoRecentListParser())
    }
}