package com.baidu.netdisk.wap.launch

import android.app.Activity
import android.content.Intent
import android.net.Uri
import android.text.TextUtils
import com.baidu.netdisk.statistics.NetdiskStatisticsLogForMutilFields
import com.baidu.netdisk.ui.cloudp2p.UserInfoActivity
import org.json.JSONObject
import java.lang.Exception

/**
 * 加好友的scheme
 *
 * @author wangyang34
 * @since 2019年9月9日
 */
class AddFriendLauncher : BaseParsable() {

    /** 来源 */
    private var mFrom: Int = IWapParsable.FROM_DEFAULT

    override fun setFrom(from: Int) {
        mFrom = from
    }

    override fun parseWapUri(activity: Activity, uri: Uri): Intent? {
        var ukText: String = try {
            uri.getQueryParameter("uk")
        } catch (ex: Exception) {
            ""
        }
        if (TextUtils.isEmpty(ukText)) {
            ukText = try {
                val jsonObject = JSONObject(uri.getQueryParameter("params"))
                jsonObject.get("uk").toString()
            } catch (ex: Exception) {
                ""
            }
        }
        val uk: Long
        try {
            uk = ukText.toLong()
        } catch (e: Exception) {
            return null
        }
        if (mFrom == IWapParsable.FROM_WAP) {
            NetdiskStatisticsLogForMutilFields.getInstance().updateCount(NetdiskStatisticsLogForMutilFields
                    .StatisticsKeys.CLOUDP2P_ADD_FRIEND_FROM_WAP)
        }
        val intent = Intent(activity, UserInfoActivity::class.java)
        intent.putExtra(UserInfoActivity.EXTRA_UK, uk)
        intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP)
        return intent
    }
}