package com.baidu.netdisk.wap.launch

import android.app.Activity
import android.content.Intent
import android.net.Uri
import android.os.Bundle
import android.text.TextUtils
import com.baidu.netdisk.ui.webview.BaseWebViewFragment
import com.baidu.netdisk.ui.webview.CommonWebViewActivity

/**
 * 通用的H5跳转器
 *
 * @author 张勇
 * @since 2019/11/12
 */

class H5Launcher : BaseParsable() {
    private val TAG = "H5Launcher"

    override fun parseWapUri(activity: Activity, uri: Uri): Intent? {

         uri?.apply {
            val url = uri.getQueryParameter(WapLaunchConstants.KEY_URL)
            takeUnless {
                TextUtils.isEmpty(url)
            }?.apply {
                val bundle = Bundle()
                bundle.putString(BaseWebViewFragment.EXTRA_URL, Uri.decode(url))
                val intent = Intent(activity.applicationContext, CommonWebViewActivity::class.java)
                intent.putExtras(bundle)
                intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK)

                return@parseWapUri intent
            }
        }

        return null
    }
}