package com.baidu.netdisk.wap.launch

import android.app.Activity
import android.content.Intent
import android.net.Uri
import android.text.TextUtils
import com.baidu.netdisk.kotlin.extension.Tag
import com.baidu.netdisk.kotlin.extension.d
import com.baidu.netdisk.statistics.NetdiskStatisticsLogForMutilFields
import com.baidu.netdisk.ui.MainActivity
import com.baidu.netdisk.xpan.statistics.AIAppsStatisticsKey
import com.baidu.swan.launcher.NetdiskSwanAppLaunchHelper

/**
 * 网盘小程序Launcher
 *
 * @author rendawei
 * @since 10.0.20
 */
@Tag("NetDiskSwanLauncher")
class NetDiskSwanLauncher : BaseParsable() {

    override fun parseWapUri(activity: Activity, uri: Uri): Intent? {
        val appKey = uri.getQueryParameter(WapLaunchConstants.KEY_SWAN_APP_KEY)
        val path = uri.getQueryParameter(WapLaunchConstants.KEY_SWAN_PATH)
        var invokeUrl = "${WapLaunchConstants.BDNETDISK_SCHEME}://swan/${appKey}"
        if (!TextUtils.isEmpty(path)) {
            invokeUrl += path
        }
        "invokeUrl:$invokeUrl".d()
        if (MainActivity.hasAlreadyLaunched()) {
            NetdiskSwanAppLaunchHelper.launch(invokeUrl)
        } else {
            MainActivity.startActivity(invokeUrl)
        }
        NetdiskStatisticsLogForMutilFields.getInstance().updateCount(
                AIAppsStatisticsKey.AIAPPS_WAP_LAUNCH_NETDISK, appKey)
        return null
    }
}