package com.baidu.netdisk.wap.launch

import android.app.Activity
import android.content.Intent
import android.net.Uri
import com.baidu.netdisk.ui.xpan.transmission.TransAssistantActivity
import com.baidu.netdisk.ui.xpan.transmission.TransFileSelectActivity
import com.baidu.netdisk.ui.xpan.transmission.TransItemDetailActivity
import com.baidu.netdisk.ui.xpan.transmission.TransListDetailActivity

/**
 * 传输助手跳转
 *
 * @author wangyang34
 * @since 2019年11月4日
 */
class TransferAssistantLauncher : BaseParsable() {

    companion object {

        private const val EXTRA_PAGE_TYPE = "page"
        private const val EXTRA_SURL = "surl"
        private const val EXTRA_TID = "tid"
        private const val EXTRA_UK = "sendUk"
        private const val EXTRA_UUID = "sendUUid"
        private const val EXTRA_TITLE = "taskName"
        private const val EXTRA_COME_FROM = "comeFrom"

        /**
         * 传输助手-首页
         */
        private const val PAGE_HOME = "home"
        /**
         * 传输助手-发送文件
         */
        private const val PAGE_SEND = "send"
        /**
         * 传输助手-详情页
         */
        private const val PAGE_DETAIL = "detail"
    }

    override fun parseWapUri(activity: Activity, uri: Uri): Intent? {
        val page = uri.getQueryParameter(EXTRA_PAGE_TYPE)
        val surl = uri.getQueryParameter(EXTRA_SURL)
        val uk = uri.getQueryParameter(EXTRA_UK)
        val tid = uri.getQueryParameter(EXTRA_TID)
        val uuid = uri.getQueryParameter(EXTRA_UUID)
        val title = uri.getQueryParameter(EXTRA_TITLE)
        val result = Int.runCatching {
            val comeFrom = uri.getQueryParameter(EXTRA_COME_FROM)
            comeFrom?.toInt() ?: TransFileSelectActivity.FROM_QRCODE
        }
        return when (page) {
            PAGE_HOME -> {
                return TransAssistantActivity.getIntent(activity, result.getOrNull() ?: -1)
            }
            PAGE_SEND -> {
                return if (result.isSuccess) {
                    TransFileSelectActivity.getIntent(activity, surl, result.getOrNull()
                            ?: TransFileSelectActivity.FROM_QRCODE)
                } else {
                    TransFileSelectActivity.getIntent(activity, surl)
                }
            }
            PAGE_DETAIL -> {
                return TransListDetailActivity.getIntent(activity, uuid, title
                        ?: "", TransItemDetailActivity.TYPE_RECEIVER)
            }
            else -> TransAssistantActivity.getIntent(activity, -1)
        }
    }
}